#!/usr/local/bin/perl

####################################################################
#	COPYRIGHT NOTICE											   #
#	Copyright 1998 Troy A. Janisch   All Rights Reserved.          #
#																   #
#	PROGRAM: sharin_prefs.pl							 	 	   #
#	VERSION: 1.0												   #
#	LICENSED TO: Online Arts   							   	       #	
#   DISTRIBUTED BY: Online Arts									   #
#																   #
#	This script may be used and modified by anyone who has paid    #
#	Their license fee.  However, this copyright/license notice	   #
#	must remain intact.  By using this program you agree to		   #
#	indemnify its creator from any liability that might arise 	   #
#	from it's use.			                                       #
#																   #
# 	Duplicating or redistributing this program without prior       #
#	written consent is expressly forbidden.  You must Obtain	   #
#	permission before redistributing this software by any means.   #
#	In all cases this copyright/license notice must remain intact. #
#																   #
#																   #
#   By distributing this program to you at a reasonably-low cost   #
#   I'm trusting that you will return the favor by protecting.     #
#   my rights and your investment. 								   #
#																   #
#	"It is impossible to go through life without trust:  		   #
#	that is to be imprisoned in the worst cell of all, oneself."   #
#										-Ralph Waldo Emerson	   #
#																   #
####################################################################
# Define the variables

####################################################################
                 
	
	$home="http://www.onlinearts.net/workshop/sharin_ware";
	$homedir="\\online\\htdocs\\workshop\\sharin_ware";
	#Where is the extensions file? (only files with these extensions can be uploaded)
 	$exts="\\online\\cgi-shl\\sharin\\extensions.txt";


	$password="password";
	
	$datadir="$homedir\\files";
	$datahome="$home/files";
	$datafields = 7;  
	$template = "$homedir\\view.template"; 
	$datafile = "$datadir\\files.txt"; 
	$weasel = "$datadir\\weasel.txt"; 
	$temporary = "$datadir\\temp.txt";
	
	
#GET TIME
sub get_time {


	$time=time;
	$time2=localtime($time);
	($wday, $month, $day, $time, $year) = split(" ",$time2,5);
	$year = substr($year,2,2);
	$month = uc($month);
	if ($month eq "DEC"){
		$month="12";
		$jmonth=334;}
	elsif ($month eq "NOV"){
		$month="11";
		$jmonth=304;}
	elsif ($month eq "OCT"){
		$month="10";
		$jmonth=273;}
	elsif ($month eq "SEP"){
		$month="9";
		$jmonth=243;}
	elsif ($month eq "AUG"){
		$month="8";
		$jmonth=212;}
	elsif ($month eq "JUL"){
		$month="7";
		$jmonth=181;}
	elsif ($month eq "JUN"){
		$month="6";
		$jmonth=151;}	
	elsif ($month eq "MAY"){
		$month="5";
		$jmonth=120;}
	elsif ($month eq "APR"){
		$month="4";
		$jmonth=90;}
	elsif ($month eq "MAR"){
		$month="3";
		$jmonth=59;}				
	elsif ($month eq "FEB"){
		$month="2";
		$jmonth=31;}
  	elsif ($month eq "JAN"){
		$month="1";
		$jmonth=0;}
		$daze="$month/$day/$year";
}

# STRIP SUBROUTINE
sub strip {

     my($cheese)= @_;
     $cheese =~ s/\t/&nbsp;/g; 
     $cheese =~ s/\|//g; 
     $cheese =~ s/\r//g;   # should use this.
     $cheese =~ s/\n/<P>/g;   # should use this.
     $cheese =~ s/%95/<li>/g;
     $cheese =~ s/"<P><P>"/<P>/g; 

      return ($cheese);
}

sub error {

	print "content-type:text/html\n\n";
	print "<HEAD><title>WHOA!</title></head>\n";
	print "<body bgcolor=\"#ffffff\" >\n";
	print "<center><TABLE width=\"520\">\n";
	print "<TR><TD colspan=\"2\"><font face=\"Verdana, Arial, Helvetica, sans-serif\"><H2>Sorry!</h2></TD></TR>\n";
	print "<TR><TD colspan=\"2\"><font face=\"Verdana, Arial, Helvetica, sans-serif\"><P>That file already exists.</p></td></tr>\n";
	print "<BR><BR><strong></strong>\n";
	print "</TABLE></center>\n";
	
	print "</BODY></HTML>\n";
	close WEASEL;
	unlink ($weasel);
	exit;
}


sub fail {

	print "content-type:text/html\n\n";
	print "<HEAD><title>Sorry!</title></head>\n";
	print "<body bgcolor=\"#ffffff\" >\n";
	print "<center><TABLE width=\"520\">\n";
	print "<TR><TD colspan=\"2\"><font face=\"Verdana, Arial, Helvetica, sans-serif\"><H2>Sorry!</h2></TD></TR>\n";
	print "<TR><TD colspan=\"2\"><font face=\"Verdana, Arial, Helvetica, sans-serif\"><P>That's not the password. </p></td></tr>\n";
	print "<BR><BR><strong></strong>\n";
	print "</TABLE></center>\n";
	
	print "</BODY></HTML>\n";
	close WEASEL;
	unlink ($weasel);
	exit;
}



# PARSE SUBROUTINE

sub parse_form {
read(STDIN, $cache, $ENV{'CONTENT_LENGTH'});
   if (length($cache) < 5) {
         $buffer = $ENV{QUERY_STRING};
    }
 
  @pairs = split(/&/, $cache);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;


	if (defined($FORM{$name})){
	$FORM{$name}.="\0";
	}


      $FORM{$name} .= &strip($value);
   }
}

#########################################
#
#  Print the matched record
#
#########################################
sub print_record {

$goober="$datahome/$field5/$field3";
$field3=$goober;

local (%listvals) = ("!FIELD1!", "$field1", "!FIELD2!", "$field2", "!FIELD3!", "$field3", "!FIELD4!", "$field4", "!FIELD5!", "$field5", "!FIELD6!", "$field6", "!FIELD7!", "$field7");
		
		local ($template) = "$template";
		open(TEMPL, "$template") || print "no file found $template!";
		$template = "";
		
		while(<TEMPL>)
		{
			$template .= $_;
			}
		
		close(TEMPL);
		
		for $ikey (keys(%listvals))
		{
			local($value) = $listvals{"$ikey"};
						
			$template =~ s/$ikey/$value/gm;
		}	
		
		print "$template\n";

 }


##########################################
#
#  Check to see if record matches search criteria
#
##########################################
sub check_record {
    # get the data from the record read from the file. $tabledata

   	$field1 =$tabledata[0];
    $field2 = $tabledata[1];
    $field3 = $tabledata[2];
    $field4 = $tabledata[3];
    $field5 = $tabledata[4];
    $field6 = $tabledata[5];
    $field7 = $tabledata[6];
    #$field8 = $tabledata[7];
	#$field9 = $tabledata[8];    
	#$field10 = $tabledata[9];
	chop($field7);

    $datafieldsearch = $field4 . " " . $field5 . " " . $field7 ;

  #search by keywords
   # only perform the keyword search if the length of the search string is greater than 2
   # don't think we want people to search for and  or or etc.
   $sfound = 0;
   $found = 0;
   $notfound = 1; 

   $stlen = length($FORM{'keys'});
   if ($stlen > 1) {
       @words = split(/ +/,$FORM{'keys'});
               foreach $aword (@words) {
           if ($datafieldsearch =~ /\b$aword/i)  {
                  $sfound = 1;
           } 

           else {
                  $notfound = 0;
            }
         }
     }
    if (($sfound == 1) && ($notfound == 1)) {
        $found = 1;
     }


    # if search string is too small .. set found to 1
    if ($stlen <= 1) {
        $found = 1;
    }
   
}






sub open_file {

  my ($filevar, $filemode, $datafile) = @_;
  
  open ($filevar,$filemode . $datafile) ||
     die ("Can't open $datafile");
}

sub read_file {

  my ($filevar) = @_;

  <$filevar>;  
}

sub write_file {

  my ($filevar, $line) = @_;

  print $filevar ($line);
}


sub date_sort
{
	my($alpha) = $b;
	my($beta) = $a;
	my($a_date, @stuff) = split(/\|/, $alpha);
	my($b_date, @stuff) = split(/\|/, $beta);
	my($result) = 0; 						# all things being equal.
	
	# print "Comparing $a_date to $b_date\n";
	my($a_month, $a_day, $a_year) = split(/\//, $a_date);
	my($b_month, $b_day, $b_year) = split(/\//, $b_date);

	# y2k patch: if less than year 32 then it must be in 2k; should store years as 4 digits
	$a_year += $a_year < 32 ? 2000 : 1900;
	$b_year += $b_year < 32 ? 2000 : 1900;
	
	
	# print "comparing $a_month, $a_day, $a_year to $b_month, $b_day, $b_year\n";
	$result = $a_year <=> $b_year;
	$result = $a_month <=> $b_month if $result == 0;
	$result = $a_day <=> $b_day if $result == 0;

	return $result;
}
sub name_sort
{
	my($alpha) = $a;
	my($beta) = $b;
	my(@a_stuff) = split(/\|/, $alpha);
	my(@b_stuff) = split(/\|/, $beta);
	my($result) = 0; 						# all things being equal.
	
	my($a_name) = $a_stuff[3];
	my($b_name) = $b_stuff[3];	
	
	$result = $a_name cmp $b_name;

	return $result;
}

sub sort_it{

	if ($FORM{'sortby'} eq "newest"){
         
        $result = ($b_items[$counter] <=> $a_items[$counter]); # for numbers
		return($result);

	}
	
	elsif ($FORM{'sortby'} eq "name"){
			my(@a_items) = split(/\|/, $a,$datafields);
	                my(@b_items) = split(/\|/, $b, $datafields);
	my($item_no) = 3;			# the number of the field to 
						# sort on.
	my($result) = 0;			# default is equal

	    $result = $a_items[$item_no] cmp $b_items[$item_no]; #for strings
        #$result = $a_items[$item_no] <=> $b_items[$item_no]; # for numbers
		return($result);
	}
	

}


# WEASEL SUBROUTINE

sub weasel{

	while (-e $weasel){
	sleep(1);
		}
}




#all required scripts must return successfully;
1;
